// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: release_lifecycle.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	ReleaseLifecycles_GetReleaseLifecycleByID_FullMethodName = "/martiancloud.phobos.api.releaselifecycle.ReleaseLifecycles/GetReleaseLifecycleByID"
	ReleaseLifecycles_GetReleaseLifecycles_FullMethodName    = "/martiancloud.phobos.api.releaselifecycle.ReleaseLifecycles/GetReleaseLifecycles"
	ReleaseLifecycles_CreateReleaseLifecycle_FullMethodName  = "/martiancloud.phobos.api.releaselifecycle.ReleaseLifecycles/CreateReleaseLifecycle"
	ReleaseLifecycles_UpdateReleaseLifecycle_FullMethodName  = "/martiancloud.phobos.api.releaselifecycle.ReleaseLifecycles/UpdateReleaseLifecycle"
	ReleaseLifecycles_DeleteReleaseLifecycle_FullMethodName  = "/martiancloud.phobos.api.releaselifecycle.ReleaseLifecycles/DeleteReleaseLifecycle"
)

// ReleaseLifecyclesClient is the client API for ReleaseLifecycles service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// ReleaseLifecycles implements all functionality related to a Phobos
// ReleaseLifecycle.
type ReleaseLifecyclesClient interface {
	// GetReleaseLifecycleByID returns a ReleaseLifecycle by an ID.
	GetReleaseLifecycleByID(ctx context.Context, in *GetReleaseLifecycleByIdRequest, opts ...grpc.CallOption) (*ReleaseLifecycle, error)
	// GetReleaseLifecycles returns a paginated list of ReleaseLifecycles.
	GetReleaseLifecycles(ctx context.Context, in *GetReleaseLifecyclesRequest, opts ...grpc.CallOption) (*GetReleaseLifecyclesResponse, error)
	// CreateReleaseLifecycle creates a new ReleaseLifecycle.
	CreateReleaseLifecycle(ctx context.Context, in *CreateReleaseLifecycleRequest, opts ...grpc.CallOption) (*ReleaseLifecycle, error)
	// UpdateReleaseLifecycle updates a new ReleaseLifecycle to a new
	// LifecycleTemplate.
	UpdateReleaseLifecycle(ctx context.Context, in *UpdateReleaseLifecycleRequest, opts ...grpc.CallOption) (*ReleaseLifecycle, error)
	// DeleteReleaseLifecycle deletes a ReleaseLifecycle.
	DeleteReleaseLifecycle(ctx context.Context, in *DeleteReleaseLifecycleRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type releaseLifecyclesClient struct {
	cc grpc.ClientConnInterface
}

func NewReleaseLifecyclesClient(cc grpc.ClientConnInterface) ReleaseLifecyclesClient {
	return &releaseLifecyclesClient{cc}
}

func (c *releaseLifecyclesClient) GetReleaseLifecycleByID(ctx context.Context, in *GetReleaseLifecycleByIdRequest, opts ...grpc.CallOption) (*ReleaseLifecycle, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ReleaseLifecycle)
	err := c.cc.Invoke(ctx, ReleaseLifecycles_GetReleaseLifecycleByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releaseLifecyclesClient) GetReleaseLifecycles(ctx context.Context, in *GetReleaseLifecyclesRequest, opts ...grpc.CallOption) (*GetReleaseLifecyclesResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetReleaseLifecyclesResponse)
	err := c.cc.Invoke(ctx, ReleaseLifecycles_GetReleaseLifecycles_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releaseLifecyclesClient) CreateReleaseLifecycle(ctx context.Context, in *CreateReleaseLifecycleRequest, opts ...grpc.CallOption) (*ReleaseLifecycle, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ReleaseLifecycle)
	err := c.cc.Invoke(ctx, ReleaseLifecycles_CreateReleaseLifecycle_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releaseLifecyclesClient) UpdateReleaseLifecycle(ctx context.Context, in *UpdateReleaseLifecycleRequest, opts ...grpc.CallOption) (*ReleaseLifecycle, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ReleaseLifecycle)
	err := c.cc.Invoke(ctx, ReleaseLifecycles_UpdateReleaseLifecycle_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releaseLifecyclesClient) DeleteReleaseLifecycle(ctx context.Context, in *DeleteReleaseLifecycleRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, ReleaseLifecycles_DeleteReleaseLifecycle_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ReleaseLifecyclesServer is the server API for ReleaseLifecycles service.
// All implementations must embed UnimplementedReleaseLifecyclesServer
// for forward compatibility.
//
// ReleaseLifecycles implements all functionality related to a Phobos
// ReleaseLifecycle.
type ReleaseLifecyclesServer interface {
	// GetReleaseLifecycleByID returns a ReleaseLifecycle by an ID.
	GetReleaseLifecycleByID(context.Context, *GetReleaseLifecycleByIdRequest) (*ReleaseLifecycle, error)
	// GetReleaseLifecycles returns a paginated list of ReleaseLifecycles.
	GetReleaseLifecycles(context.Context, *GetReleaseLifecyclesRequest) (*GetReleaseLifecyclesResponse, error)
	// CreateReleaseLifecycle creates a new ReleaseLifecycle.
	CreateReleaseLifecycle(context.Context, *CreateReleaseLifecycleRequest) (*ReleaseLifecycle, error)
	// UpdateReleaseLifecycle updates a new ReleaseLifecycle to a new
	// LifecycleTemplate.
	UpdateReleaseLifecycle(context.Context, *UpdateReleaseLifecycleRequest) (*ReleaseLifecycle, error)
	// DeleteReleaseLifecycle deletes a ReleaseLifecycle.
	DeleteReleaseLifecycle(context.Context, *DeleteReleaseLifecycleRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedReleaseLifecyclesServer()
}

// UnimplementedReleaseLifecyclesServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedReleaseLifecyclesServer struct{}

func (UnimplementedReleaseLifecyclesServer) GetReleaseLifecycleByID(context.Context, *GetReleaseLifecycleByIdRequest) (*ReleaseLifecycle, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetReleaseLifecycleByID not implemented")
}
func (UnimplementedReleaseLifecyclesServer) GetReleaseLifecycles(context.Context, *GetReleaseLifecyclesRequest) (*GetReleaseLifecyclesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetReleaseLifecycles not implemented")
}
func (UnimplementedReleaseLifecyclesServer) CreateReleaseLifecycle(context.Context, *CreateReleaseLifecycleRequest) (*ReleaseLifecycle, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateReleaseLifecycle not implemented")
}
func (UnimplementedReleaseLifecyclesServer) UpdateReleaseLifecycle(context.Context, *UpdateReleaseLifecycleRequest) (*ReleaseLifecycle, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateReleaseLifecycle not implemented")
}
func (UnimplementedReleaseLifecyclesServer) DeleteReleaseLifecycle(context.Context, *DeleteReleaseLifecycleRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteReleaseLifecycle not implemented")
}
func (UnimplementedReleaseLifecyclesServer) mustEmbedUnimplementedReleaseLifecyclesServer() {}
func (UnimplementedReleaseLifecyclesServer) testEmbeddedByValue()                           {}

// UnsafeReleaseLifecyclesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ReleaseLifecyclesServer will
// result in compilation errors.
type UnsafeReleaseLifecyclesServer interface {
	mustEmbedUnimplementedReleaseLifecyclesServer()
}

func RegisterReleaseLifecyclesServer(s grpc.ServiceRegistrar, srv ReleaseLifecyclesServer) {
	// If the following call pancis, it indicates UnimplementedReleaseLifecyclesServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&ReleaseLifecycles_ServiceDesc, srv)
}

func _ReleaseLifecycles_GetReleaseLifecycleByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetReleaseLifecycleByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleaseLifecyclesServer).GetReleaseLifecycleByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ReleaseLifecycles_GetReleaseLifecycleByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleaseLifecyclesServer).GetReleaseLifecycleByID(ctx, req.(*GetReleaseLifecycleByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ReleaseLifecycles_GetReleaseLifecycles_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetReleaseLifecyclesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleaseLifecyclesServer).GetReleaseLifecycles(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ReleaseLifecycles_GetReleaseLifecycles_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleaseLifecyclesServer).GetReleaseLifecycles(ctx, req.(*GetReleaseLifecyclesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ReleaseLifecycles_CreateReleaseLifecycle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateReleaseLifecycleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleaseLifecyclesServer).CreateReleaseLifecycle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ReleaseLifecycles_CreateReleaseLifecycle_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleaseLifecyclesServer).CreateReleaseLifecycle(ctx, req.(*CreateReleaseLifecycleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ReleaseLifecycles_UpdateReleaseLifecycle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateReleaseLifecycleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleaseLifecyclesServer).UpdateReleaseLifecycle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ReleaseLifecycles_UpdateReleaseLifecycle_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleaseLifecyclesServer).UpdateReleaseLifecycle(ctx, req.(*UpdateReleaseLifecycleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ReleaseLifecycles_DeleteReleaseLifecycle_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteReleaseLifecycleRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleaseLifecyclesServer).DeleteReleaseLifecycle(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: ReleaseLifecycles_DeleteReleaseLifecycle_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleaseLifecyclesServer).DeleteReleaseLifecycle(ctx, req.(*DeleteReleaseLifecycleRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// ReleaseLifecycles_ServiceDesc is the grpc.ServiceDesc for ReleaseLifecycles service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ReleaseLifecycles_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.releaselifecycle.ReleaseLifecycles",
	HandlerType: (*ReleaseLifecyclesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetReleaseLifecycleByID",
			Handler:    _ReleaseLifecycles_GetReleaseLifecycleByID_Handler,
		},
		{
			MethodName: "GetReleaseLifecycles",
			Handler:    _ReleaseLifecycles_GetReleaseLifecycles_Handler,
		},
		{
			MethodName: "CreateReleaseLifecycle",
			Handler:    _ReleaseLifecycles_CreateReleaseLifecycle_Handler,
		},
		{
			MethodName: "UpdateReleaseLifecycle",
			Handler:    _ReleaseLifecycles_UpdateReleaseLifecycle_Handler,
		},
		{
			MethodName: "DeleteReleaseLifecycle",
			Handler:    _ReleaseLifecycles_DeleteReleaseLifecycle_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "release_lifecycle.proto",
}
